class DistanceEstimator{
	static lineToCircle(a,b,o,size){//unfinnished
		let ab=Math.len2(a,b);
		let ao=Math.len2(a,o);
		let bo=Math.len2(b,o);
		let x=[0,0];
		x[0]=(Math.pow(ab,2)+Math.pow(ao,2)-Math.pow(bo,2))/(2*ab);
		x[1]=Math.pow(Math.pow(ao,2)-Math.pow(x[0],2),0.5);
		if(x[1]<size&&x[0]>=0){
			let dist = Math.abs(x[0])-Math.pow(Math.pow(size,2)-Math.pow(x[1],2),0.5);
			return(dist);//Math.max(Math.len2(ab)-size,dist));
		}
		return false;
	}
	static lineToRect(aC,bC,rectPos){
		let a=Math.rotate(Math.dif2(aC,rectPos.coords),-rectPos.rotation,0,1);
		let b=Math.rotate(Math.dif2(bC,rectPos.coords),-rectPos.rotation,0,1);
		let ab=Math.len2(a,b);
		let atob=Math.minusVec2(b,a);
		let g=[(atob[0]<0)*2-1,(atob[1]<0)*2-1];
		let d=[
			(a[0]-rectPos.size[0]/2*g[0])/atob[0]*ab,
			(a[1]-rectPos.size[1]/2*g[0])/atob[1]*ab
		];
		let dists=[
			-(a[0]-rectPos.size[0]/2*g[0])/atob[0]*ab,
			-(a[1]-rectPos.size[1]/2*g[1])/atob[1]*ab,
		];
		let distsFar=[
			-(a[0]+rectPos.size[0]/2*g[0])/atob[0]*ab,
			-(a[1]+rectPos.size[1]/2*g[1])/atob[1]*ab,
		];
		let range=[
			Math.max(dists[0],dists[1]),
			Math.min(distsFar[0],distsFar[1]),
		];
		if(range[0]<range[1]){
			return [true,range[0],range[1]];
		}
		
		return [false,range[0],range[1]];
	}
	static lineToRectReflect(aC,bC,rectPos){
		let a=Math.rotate(Math.dif2(aC,rectPos.coords),-rectPos.rotation,0,1);
		let b=Math.rotate(Math.dif2(bC,rectPos.coords),-rectPos.rotation,0,1);
		let ab=Math.len2(a,b);
		let atob=Math.minusVec2(b,a);
		for (let i = 0; i < 2; i++) {
			if(a[i]>=rectPos.size[i]/2){
				atob[i]=Math.abs(atob[i]);
			}
			if(a[i]<=-rectPos.size[i]/2){
				atob[i]=-Math.abs(atob[i]);
			}
			b[i]=a[i]+atob[i];
		}
		a=Math.rotate(a,rectPos.rotation,0,1);
		b=Math.rotate(b,rectPos.rotation,0,1);
		return Math.minusVec2(b,a);
	}
}
fastSphere=function(coords,ray,size){
	c=doAB((a,b)=>{return(0)},coords,coords);
	a=coords;
	b=doAB((c,d)=>{return(c+d);},coords,clone(ray.direction));
	let ab = getLength(doAB((a,b)=>{return(a-b);},a,b));
	let ac = getLength(doAB((a,b)=>{return(a-b);},a,c));
	let bc = getLength(doAB((a,b)=>{return(a-b);},b,c));
	let ax = (Math.pow(ab,2)+Math.pow(ac,2)-Math.pow(bc,2))/(2*ab);
	let cx = Math.pow(Math.pow(ac,2)-Math.pow(ax,2),0.5)
	if(cx>size){
		return(100000*getLength(coords)-size);
	}
	else{
		let dist = Math.abs(ax) -Math.pow(Math.pow(size,2)-Math.pow(cx,2),0.5);
		if(dist<0.01){ray.distsAdd=1*Math.pow((size-cx+1)*ax,-1);}
		return(Math.max(getLength(coords)-size,dist));
	}
};